Historie systemovych knihoven SofCon:
+++++++++++++++++++++++++++++++++++++

Ver 05.10,23.09.2005	Wil
  Opravy a upravy knihoven:
    HwSyst	Net,Wil
	- Pridana podpora IRQ>7 pro PC.
    Retos	Net,Wil
	- Slouceni Globals.imp, Except.imp, Intr.imp, Kernel.imp, Queues.imp
	  primo do Kernel.pas.
	- Upravy pro DPMI rezim, zbyva dodelat spravne zjisteni adresy
	  pripadne chyby v ExitProc pro DPM.
    ChnCom,	Net,Wil
    ChnComT,	Wil
    ChnCAN1,	Wil
	- Pridana podpora IRQ>7 pro PC.
    uIOFlex2	Tum
	- Opravena fce UnlockChip - zapomenute PopF kdyz neprosla prvni podminka

Ver 05.00,14.06.2005	Wil
  Vytvorene nove knihovny:
    Chn188	Wil
        - obsluha serioveho komunikacniho portu na
          konektoru X2 procesoru Kit188ER
    BiosCfg	Wil
        - obsluha konfiguracni tabulky BIOSu (zatim jen pro Kit386)
    CFlash	Wil
	- obsluha CompactFlash karty na procesorove desce Kit188
	  s absolutnim pristupem do vyhrazeneho linearniho prostoru.

  Opravy a upravy knihoven:
    LdrLib	Wil
	- Knihovny LdrLib rozsireny o moznost zapisu (update) konfiguracni
          tabulky BIOSu (zatim jen pro Kit386) a dale doplneny o funkce
          pro uzivatelske zpracovani cteni a zapisu OnLine parametru
          specifickych pro dany Loader.
    ChnCAN1	Wil
	- Oprava ChClose 2.kanalu - prepis pameti.
	- Oprava pri vysilani - obcas se vysilaly prazdne
          zpravy, zejmena po ChSendFlush.
	- Pridana funkce ChnCan1_ResultToStr.
    NumToStr	Wil
        - Optimalizace vetsiny zakladnich funkci kvuli uspore Stacku do ASM.
    CrtCom	Wil
	- Oprava pri inicializaci Videoram. V nekterych pripadech
	  mohlo dochazet k resetu.
	- Vylepseni prijimaciho automatu - pokud je od CrtTerminalu
	  prijato vice zprav, vyctou se vsechny najednou a odpovida
	  se na tu posledni.
    ChnCom	Wil
        - Pridana obsluha FIFO.
	- Pridany citace poctu preruseni.
	- Pridana detekce nefungujiciho IRQ pri vysilani.
	- Oprava Full duplexniho rezimu (metoda ChReceiveFlush
	  rusila pripadne vysilani).
	- Pridana funkce ChnCom_ResultToStr.
    ChnCom2	Wil
        - Pridana obsluha FIFO.
	- Pridany citace poctu preruseni.
	- Pridana detekce nefungujiciho IRQ pri vysilani.
	- Oprava Full duplexniho rezimu (metoda ChReceiveFlush
	  rusila pripadne vysilani).
	- Signal INT z 8250 zustava ve 3tim stavu, tj. nepripojuje
	  se na zadny INT procesoru.
	- Pridana funkce ChnCom2_ResultToStr.
    ChnComBR,	Wil
    ChnComPB
	- Upravy podle nove ChnCom v04.60.
	- Pridana funkce ChnComBR_ResultToStr do jednotky ChnComBR.
	- Pridana funkce ChnComPB_ResultToStr do jednotky ChnComPB.
    ChnComT	Wil
        - Pridana obsluha FIFO.
	- Pridany citace poctu preruseni.
	- Pridana detekce nefungujiciho IRQ pri vysilani.
	- Oprava Full duplexniho rezimu (metoda ChReceiveFlush
	  rusila pripadne vysilani).
	- Pridana funkce ChnComT_ResultToStr.
	- Vylepseno sledovani casovych mezer mezi prijatymi znaky
          v prerusovaci rutine.
	- Upravy aby byla knihovna pouzitelna i pro Kit188ER.
    ChnMBox	Wil
	- Pridana metoda ChConnect, ktera kontroluje nastaveni
	  prijimacich a vysilacich bufferu.
	- Pridana funkce ChnComBR_ResultToStr.
    ChnVirt	Wil
	- Pridana funkce ChnVirt_ResultToStr.
    ChnV40T	Wil
	- Pridany citace poctu preruseni.
	- Oprava osetreni chyby preteceni prijimaciho bufferu
          v prerusovaci rutine.
	- Pridana detekce nefungujiciho IRQ pri vysilani.
	- Pridana funkce ChnV40T_ResultToStr.
	- Vylepseno sledovani casovych mezer mezi prijatymi znaky
          v prerusovaci rutine.
    ChnV40	Wil
	- Pridany chybove kody res_ErrRecBuffOvf, res_ErrOverrun,
	  res_ErrParity, res_ErrFraming, res_BreakInt.
	- Pridana funkce ChnV40_ResultToStr.
    ChnV40_	Wil
	- Pridany citace poctu preruseni.
	- Oprava osetreni chyby preteceni prijimaciho bufferu
          v prerusovaci rutine.
	- Pridany chybove kody res_ErrRecBuffOvf, res_ErrOverrun,
	  res_ErrParity, res_ErrFraming, res_BreakInt.
	- Pridana detekce nefungujiciho IRQ pri vysilani.
	- Pridana funkce ChnV40__ResultToStr.
    ChnDF1,	Wil
    ChnAdam,
    ChnEB,
    ChnFesto,
    ChnFT1_2,
    ChnGSM,
    ChnICS,
    ChnITCH1,
    ChnLecom,
    ChnMod2,
    ChnModB,
    ChnPrt,
    ChnSBus,
    ChnSMS,
    ChnSofS2,
    ChnTecom,
    ChnVMMA
	- Pridana funkce ChnXxx_ResultToStr.
    FstTimer
	- Opravy reentrantnosti a zaokrouhlovaci chyby.
	- Prejmenovani objektu tTimer na tFstTimer, aby nebyl
	  zamenitelny s objektem tTimer z knihovny Timer.
	- Zruseny funkce GetTime a IncTimeIrq0 - nejsou potreba.
	- Upravy pro Kit188.
    Tick
	- Ve zrychlene vetvi preruseni se inkrementuje lokalni citac,
	  ktery je dostupny pomoci funkce GetFastTime. Pokud neni
	  nainicializovan driver zrychleneho casovace, vraci GetFastTime
	  citac standardniho poctu preruseni (stejne jako INT 1Ah).
    KitKing
	- Metoda SetResultCode u objektu TWinTickVirt a vsech jeho potomku
	  rozsirena o kod online parametru, ktery zpusobil pripadnou chybu.
          Tim ma uzivatel krom kodu chyby k dispozici i informaci o kodu
	  online parametru, ktery chybu (cteni/zapisu parametru) zpusobil.
	  Objekty, ktere tento parametr nepouzivaji, do nej vkladaji hodnotu 0.

  Preklad knihoven i pro FreeDOS na Kit188ER.

Ver 04.00,06.09.2004	Wil
	- U kazde knihovny upraven History.txt do jednotneho
	  formatu.
	- U fontu pro Windows (.FON) upraven nazev fontu dle nazvu
          souboru. Tento nazev ma kazdy font jedinecny, tj. tim lze
          do Windows prilinkovat libovolne fonty.
          Drive byl nazev vsech fontu stejny, tj. do Windows
          bylo mozne prilinkovat pouze jeden z nich.
	- Nekompatibilni upravy knihoven HWsyst a Tick se starsimi
	  aplikacemi, ktere pri prekladu zahlasi "Unknown Identifier"
	  na nektere jiz neexistujici promenne. Podrobny popis upravy
	  starsich aplikaci popsan v manualech Hwsyst a Tick.
	- Rozdeleni knihoven SofCon na nasledujici baliky:
		Lib  - systemove knihovny
		LibT - puvodni nadstavba pro terminaly a menu
		LibV - nove knihovny pro terminaly, menu a touch screen

   Nove knihovny
     uIOFlex2	Pri,Cer,Wil
	- Prvni vydani.
     uFlx2Pos	Pri,Web,Wil
	- Prvni vydani.
     Lz77	Cer
	- Prvni vydani.
     CrtCom	Wil
	- Balik knihoven pro ladici vypisy na vzdaleny Crt terminal
	  po seriove komunikacni lince.

   SW upravy jednotlivych knihoven
     HWsyst	Hvo, Wil
	- Pridana funkce MemCmp.
	- Pridany funkce pro praci s CS: GetCSAddr,
          GetCSSize, GetCSType.
        - Opravena chyba ve funkci GetBaseAddr ve verzi pro DOS.
        - Pridana konstanta popisujici typ pameti - hwsysReserved.
        - Pridano pole obsahujici velikosti v KB.
        - Funkce GetOpMemory, GetChipSize, GetMemoryType, GetDelay
          byly doplneny o podporu KitV40.
        - Prejmenovana funkce GetDelay na GetAcessTime.
        - Zmeny poznamek.
	- Byla zrušena proměnná IRQTime. Pokud vám při překladu
	  stávajících aplikací s touto verzí knihovny překladač
	  hlásí chybu „Unknown Identifier“, nahraďte proměnnou
	  IRQTime za ActIRQTime. V žádném případě byste však
	  neměli hodnotu proměnné ActIRQTime měnit, tj. pokud
	  jste v aplikaci volali např. „IRQTime := 60“, můžete
	  toto volání zrušit – nenahrazovat za „ActIRQTime := 60“.
	  Pozn: Ruční nastavení IRQTime bylo dříve nutné pro
	  korekci měření časů, v současné době se tato korekce
	  provádí automaticky.
	- Zrusena promenna IRQpSec a nahrazena za DefIRQpSec,
	  ActIRQpSec.
	- Zrusena promenna IRQpDay a nahrazena za DefIRQpDay,
	  ActIRQpDay.
	- Pridany funkce SetTimer, GetTimer, GetRealIRQTime,
	  ReadTimer0.
	- Oprava periody systemoveho casovace pro Kit386 33MHz
	  z 55,606ms na 54,999ms tj. presnejsi casovani.
	- Oprava periody systemoveho casovace pro KitV40
	  z 54,926ms na 55,000ms tj. presnejsi casovani.
	- Pridany konstanty a procedury pro obsluhu radice
	  preruseni.
	- Zmena funkci GetOpMemory, GetChipSize a GetCSSize.
	  Drive tyto funkce vracely kod velikosti pameti, ktery
	  se pote musel prevest. V teto nove verzi knihovny
	  tyto funkce vraci primo velikost v KB.
	- Pridany funkce PtrToAbsAddr a AbsAddrToPtr.
	- Pridany inline procedury PushfCli a Popf.
     Tick	Wil
	- Pridana konstanta TickInt = $08.
	- SetTimeUser1 lze volat i vicekrat za sebou, coz do ted
          nebylo mozne pri zmene IRQTime. Navic SetTimeUser1
	  provadi korekce periody nezrychleneho casovace kvuli
	  odmerovani casovych intervalu. Do ted to musela delat
	  aplikace upravou promenne IRQTime z HWsyst.
	- Zmena inicializace ExitProc - ExitProc se nastavuje
	  az volanim InitTick/InitTickI (do ted se nastavovala
	  ihned pri prilinkovani knihovny do aplikace).
	- Pridana procedura DoneTick, ktera obnovuje puvodni casovac
	  a nastavi puvodni ExitProc, jaka byla pred InitTick(I).
	- Procedura SetTimer presunuta do HWSyst.
	- Pridany promenne FastIRQxxx, ktere udavaji udaje
	  o "zrychlenem" casovaci.
	- V pripade zrychlene komunikace na V40 se korekce casovace
	  provadi automaticky. Neni tedy nutno korekci provadet
	  rucne v aplikaci pomoci promenne TickDivider.
	- Pridana procedura SetTimerUser2 pro nastaveni periody
	  puvodni obsluhy preruseni a User2.
	- Promenna TickDivider presunuta do implementation sekce,
	  tj. neni vne unity pristupna. Stavajici aplikace ji pouzivaly
	  pro korekci casovace pri inicializaci komunikace V40,
	  ktera se ted provadi jiz automaticky, tj. promennou
	  TickDivider nastavovat nepotrebuji (jeji hodnotu lze zjistit
	  funkci GetTickDivider).
	- Pridana procedura SetTimeUser2 pro moznost zrychleni
	  i UserTick2 (za predpokladu, ze je zrychlen UserTick1).
     Sum8	Wil
	- Do objektu tSum8 pridany metody CalculateSum,
	  CheckSum.
	- Pridana funkce CalculateSum8.
     Xor8	Wil
	- Do objektu tXor8 pridany metody CalculateSum,
	  CheckSum.
	- Pridana funkce CalculateXor8.
     _1stUnit	Wil
	- Oddeleni teto knihovny od baliku KitKing.
	- Optimalizace Exit procedury.
     LibVer	Wil
	- Pridany funkce TestLibVer, IncVerNo, CheckVerNo.
	- Optimalizace funkce GetVerPackDate.
	- Oprava funkce GetVerDateStr.
     Archive	Hvo,Wil,Tum
	(AVirt)
	- Drobne optimalizace kodu.
	(ChAVirt)
	- Oprava chyby v inkrementalnim cteni,
          ktera zpusobovala pri prepisu polozek
          neprecteni vsech novych polozek tzn. dalsi ztratu.
	- Zmena prace s priznakem chaf_LostDataForRead
          doplnena funkce GetUnreadRecordNo vracejici
          pocet neprectenych polozek v archivu
	- Doplnena funkce IsLostUnreadRecord
          pro zjisteni zda doslo ke ztrate dat urcenych pro cteni.
          Funkce zaroven nastavi chaf_LostDataForRead.
	- Drobne optimalizace kodu.
        (ChATypes)
	- Oprava dekodovani retezce Key v tDscr.Init.
	- Uprava komentaru a zmena vyznamu chaf_LostDataForRead.
     AtmFlash	Hvo,Net
	- Zmena deklarace funkci, pridan prefix "a".
        - Zverejneni promennych ovlivnujicich zapisove funkce.
	- Funkce ATMWrite, ATMDestruct, ATMTotalDestruct neprovadi
          identifikaci pameti.
	- Pridan priznak pro omezeni zapisu stejnych dat, pouziva
          zejmena LOADER.
        - Oprava identifikace AT29C040A v 8b rezimu.
        - Doplnen preklad pro DOS.
	- Uprava pro Kit188ER.
        - Zatim neopraven problem s identifikaci AT29C040A v
          16b rezimu. Tuto chybu lze obejit pomoci nastaveni nove
          zverejnenych konstant.
     CrtWin	Wil
	- Pridani konstruktoru InitNoFrame.
	- Pridani funkce GetCursor.
	- Oprava pri volani samotne metody PlaceFrame.
	- Metody Save a Restore zarazeny mezi privatni.
	- Upravy komentaru.
     CrtWin2	Wil
	- Pridani konstruktoru InitNoFrame.
	- Pridani funkce GetCursor.
	- Oprava pri volani samotne metody PlaceFrame.
	- Metody Save a Restore zarazeny mezi privatni.
	- Upravy komentaru.
	- Pridana procedure CrtClose uvolnujici alokovanou pamet.
     DiskIO	Hvo
        - Upravy komentaru.
 	- Zviditelnena konstanta obsahujici velikost sektoru.
        - V Debug verzi doplnena funkce PrintDiskInfo.
	- Upravy pouziti funkci GetOpMemory a GetChipSize
	  podle noveho HWsyst.
     ChnTypes	Wil
	- Presunuti konstant IRQxx a typu tIrq do HWsyst.
     Chn	Wil
        - Oprava chyby: Metoda ChReceiveReady nenastavovala ChReceiveResult
	  z nasledujici vrstvy.
     ChnAdam	Wil
	- Prechod na standardni direktivy prekladu Ver60 a Ver70.
	- Optimalizace prijmu a vysilani.
	- Vyuzivani navratovych kodu:
		res_ErrNoRecBuff     = nedefinovany prijimaci buffer
		res_ErrSmallRecBuff  = maly prijimaci buffer
		res_ErrNoSendBuff    = nedefinovany vysilaci buffer
		res_ErrSmallSendBuff = maly vysilaci buffer
        - Metoda ChReceiveResult vraci i pripadne chyby nizsi (fyzicke)
          vrstvy (napr chybu parity, overrun apod).
	- Zmena hodnot navratovych kodu res_ErrFrame, res_ErrSum
	- Pridani navratoveho kodu res_ErrUnknownCmd = neznamy Cmd
     ChnCAN1	Hvo, Wil
        - Prepracovana verze ChnCan1 pro potreby CANopen.
	- Upraveny ladici vypisy knihovny do vystupniho souboru.
        - Lepsi osetreni BUS-OFF.
        - Moznost provadet vlastni osetreni chyb.
        - Zrychleni cteni z Sja1000.
	- Pouzivani procedur pro nastavovani a povolovani
	  IRQ z HwSyst.
     ChnCom	Wil,
     ChnCom2	Wil,
     ChnComT	Wil,
     ChnV40_	Wil,
     ChnV40P	Wil,
     ChnV40T	Wil
        - Pokud CH_Chn<>nil (existuje zretezena knihovna) vraci
          ChResult po ChOpen chybu res_ErrIllegalUnit (tyto knihovny
          jsou knihovnami nejnizsi fyzicke vrstvy a proto se nemohou
          odkazovat na zadnou jinou nizsi).
	- Neni-li nastaven prijimaci buffer, vrati se po volani
	  metody ChConnect chyba res_ErrNoRecBuff.
     ChnCom	Wil
	- Pridany chybove kody res_ErrRecBuffOvf, res_ErrOverrun,
	  res_ErrParity, res_ErrFraming, res_BreakInt.
	- Pouzivani procedur pro nastavovani a povolovani
	  IRQ z HwSyst.
	- Zjednodusena obsluha pri IRQ=2 - ubrani 4 nadbytecnych
	  prerusovacich rutin.
     ChnV40T	Wil,
     ChnComT	Wil
	- Automaticke zjistovani parametru TFR a THI, tj. v ChSetParam
	  je aplikace nemusi pouzivat.
     ChnDF1	Wil
	- Rozsireni prijmu o rozliseni chyb res_ErrFrame,
	  res_ErrSum, res_ErrLen.
	- Vyuzivani navratovych kodu:
		res_ErrNoRecBuff     = nedefinovany prijimaci buffer
		res_ErrSmallRecBuff  = maly prijimaci buffer
		res_ErrNoSendBuff    = nedefinovany vysilaci buffer
		res_ErrSmallSendBuff = maly vysilaci buffer
	- Pokud neni definovana nizsi vrstva, vraci se po volani
	  ChConnect chyba res_ErrChannelNoExist.
        - Metoda ChReceiveResult vraci i pripadne chyby nizsi (fyzicke)
          vrstvy (napr chybu parity, overrun apod).
     ChnEB	Wil
	- Rozsireni prijmu a vysilani o rozliseni chyb res_ErrFrame,
	  res_ErrSum, res_ErrLen, res_ErrVal.
	- Pokud neni definovana nizsi vrstva, vraci se po volani
	  ChConnect chyba res_ErrChannelNoExist.
	- Vyuzivani navratovych kodu:
		res_ErrNoRecBuff     = nedefinovany prijimaci buffer
		res_ErrSmallRecBuff  = maly prijimaci buffer
		res_ErrNoSendBuff    = nedefinovany vysilaci buffer
		res_ErrSmallSendBuff = maly vysilaci buffer
        - Metoda ChReceiveResult vraci i pripadne chyby nizsi (fyzicke)
          vrstvy (napr chybu parity, overrun apod).
	- Optimalizace prace s textovymi retezci pri vysilani.
     ChnFesto	Wil
	- Rozsireni prijmu a vysilani o rozliseni chyb res_ErrFrame,
	  res_ErrLen, res_ErrUnknownCode.
	- Zrusena konstanta res_ErrMsgFrame (nahrazena konstantou
	  res_ErrFrame).
	- Pokud neni definovana nizsi vrstva, vraci se po volani
	  ChConnect chyba res_ErrChannelNoExist.
	- Pokud je nizsi vrstva jina nez obvod i8250 (COM) nebo i8251 (V40)
	  vraci prijem chybu res_ErrIllegalUnit.
	- Vyuzivani navratovych kodu:
		res_ErrNoRecBuff     = nedefinovany prijimaci buffer
		res_ErrSmallRecBuff  = maly prijimaci buffer
		res_ErrNoSendBuff    = nedefinovany vysilaci buffer
		res_ErrSmallSendBuff = maly vysilaci buffer
        - Metoda ChReceiveResult vraci i pripadne chyby nizsi (fyzicke)
          vrstvy (napr chybu parity, overrun apod).
     ChnFt1_2	Wil
	- Zmena cislovani resultu Res_ErrFrame, Res_ErrSum,
	  Res_ErrLen, Res_ErrCode dle standardu.
	- Pokud neni definovana nizsi vrstva, vraci se po volani
	  ChConnect chyba res_ErrChannelNoExist.
	- Vyuzivani navratovych kodu:
		res_ErrNoRecBuff     = nedefinovany prijimaci buffer
		res_ErrSmallRecBuff  = maly prijimaci buffer
		res_ErrNoSendBuff    = nedefinovany vysilaci buffer
		res_ErrSmallSendBuff = maly vysilaci buffer
        - Metoda ChReceiveResult vraci i pripadne chyby nizsi (fyzicke)
          vrstvy (napr chybu parity, overrun apod).
     ChnGSM	Wil
	- Uprava komentaru.
	- Optimalizace internich funkci.
     ChnICS	Wil
	- Rozsireni prijmu o rozliseni chyb res_ErrFrame,
	  res_ErrSum, res_ErrLen, res_ErrVal, res_ErrETX, res_ErrEOT.
	- Vyuzivani navratovych kodu:
		res_ErrNoRecBuff     = nedefinovany prijimaci buffer
		res_ErrSmallRecBuff  = maly prijimaci buffer
		res_ErrNoSendBuff    = nedefinovany vysilaci buffer
		res_ErrSmallSendBuff = maly vysilaci buffer
	- Pokud neni definovana nizsi vrstva, vraci se po volani
	  ChConnect chyba res_ErrChannelNoExist.
        - Metoda ChReceiveResult vraci i pripadne chyby nizsi (fyzicke)
          vrstvy (napr chybu parity, overrun apod).
     ChnITCH1	Wil
	- Rozsireni prijmu o rozliseni chyb res_ErrFrame,
	  res_ErrSum.
	- Vyuzivani navratovych kodu:
		res_ErrNoRecBuff     = nedefinovany prijimaci buffer
		res_ErrSmallRecBuff  = maly prijimaci buffer
		res_ErrNoSendBuff    = nedefinovany vysilaci buffer
		res_ErrSmallSendBuff = maly vysilaci buffer
	- Pokud neni definovana nizsi vrstva, vraci se po volani
	  ChConnect chyba res_ErrChannelNoExist.
        - Metoda ChReceiveResult vraci i pripadne chyby nizsi (fyzicke)
          vrstvy (napr chybu parity, overrun apod).
     ChnLecom	Wil
	- Rozsireni prijmu o rozliseni chyb res_ErrFrame,
	  res_ErrSum, res_ErrCode, res_ErrEOT.
	- Vyuzivani navratovych kodu:
		res_ErrNoRecBuff     = nedefinovany prijimaci buffer
		res_ErrSmallRecBuff  = maly prijimaci buffer
		res_ErrNoSendBuff    = nedefinovany vysilaci buffer
		res_ErrSmallSendBuff = maly vysilaci buffer
	- Pokud neni definovana nizsi vrstva, vraci se po volani
	  ChConnect chyba res_ErrChannelNoExist.
	- Metoda ChReceiveResult vraci i pripadne chyby nizsi
	  (fyzicke) vrstvy (napr chybu parity, overrun apod).
	- Optimalizace pri vysilani.
     ChnMBox	Wil
	- Opravena a zoptimalizovana interni funkce ReadPtr.
     ChnModB	Wil
	- Rozsireni prijmu a vysilani o rozliseni chyb
	  res_ErrLen, res_ErrCrc, res_ErrUnknownCode.
	- Vyuzivani navratovych kodu:
		res_ErrNoRecBuff     = nedefinovany prijimaci buffer
		res_ErrNoSendBuff    = nedefinovany vysilaci buffer
		res_ErrSmallSendBuff = maly vysilaci buffer
	- Pokud neni definovana nizsi vrstva, vraci se po volani
	  ChConnect chyba res_ErrChannelNoExist.
        - Metoda ChReceiveResult vraci i pripadne chyby nizsi (fyzicke)
          vrstvy (napr chybu parity, overrun apod).
     ChnPrt	Wil
	- Precislovani resultu res_ErrFrame, res_ErrCrc, res_ErrLen,
	  res_ErrSOH, res_ErrETX dle standardu.
	- Vyuzivani navratovych kodu:
		res_ErrNoRecBuff     = nedefinovany prijimaci buffer
		res_ErrSmallRecBuff  = maly prijimaci buffer
		res_ErrNoSendBuff    = nedefinovany vysilaci buffer
		res_ErrSmallSendBuff = maly vysilaci buffer
	- Pokud neni definovana nizsi vrstva, vraci se po volani
	  ChConnect chyba res_ErrChannelNoExist.
        - Metoda ChReceiveResult vraci i pripadne chyby nizsi (fyzicke)
          vrstvy (napr chybu parity, overrun apod).
     ChnSBus	Wil
	- Rozsireni prijmu o rozliseni chyb res_ErrFrame,
	  res_ErrCrc, res_ErrLen, res_ErrVal, res_ErrUnknownCode.
	- Vyuzivani navratovych kodu:
		res_ErrNoRecBuff     = nedefinovany prijimaci buffer
		res_ErrSmallRecBuff  = maly prijimaci buffer
		res_ErrNoSendBuff    = nedefinovany vysilaci buffer
		res_ErrSmallSendBuff = maly vysilaci buffer
	- Pokud neni definovana nizsi vrstva, vraci se po volani
	  ChConnect chyba res_ErrChannelNoExist.
        - Metoda ChReceiveResult vraci i pripadne chyby nizsi (fyzicke)
          vrstvy (napr chybu parity, overrun apod).
	- Optimalizace vysilani.
	- Opraven prijem v pripade DataMode
	- Opraven prijem roku 2000
     ChnSMS	Wil
        uSMS
	- Optimalizace operaci s retezci
        ChnSMS
	- Optimalizace operaci s retezci 
     ChnSofS2	Wil
	- Pridany resulty res_ErrChannelNoExist,
          res_ErrNoRecBuff, res_ErrNoSendBuff po chybnem
          volani ChConnect.
	- Pridany resulty res_ErrNoRecBuff, res_ErrSmallRecBuff
	  pri prijmu zpravy.
	- Pridany resulty res_ErrNoSendBuff, res_ErrSmallSendBuff
	  pri vysilani zpravy.
	- Odstranena nepouzivana konstanta res_ErrLen.
	- Odstraneny nepouzivane unity z uses sekce.
     ChnTecom	Wil
	- Pridani vyhodnocovani chyb pri prijmu ci vysilani
	  res_ErrLen, res_ErrSum, res_ErrFrame, res_ErrVal,
          res_ErrUnknownCode.
	- Pokud neni definovana nizsi vrstva, vrati se po ChConnect
	  chyba res_ErrChannelNoExist.
	- Rozsireni vysilani o resulty res_ErrSmallSendBuff,
          res_ErrNoSendBuff.
	- Rozsireni prijmu o resulty res_ErrNoRecBuff.
	- Metoda ChReceiveResult vraci i pripadne chyby nizsi
	  (fyzicke) vrstvy (napr chybu parity, overrun apod).
     ChnTypes	Wil
	- Pridana konstanta ComFCR.
     ChnV40	Wil,
     ChnV40_	Wil,
     ChnV40P	Wil,
     ChnV40T	Wil
        - Pokud CH_Chn<>nil (existuje zretezena knihovna) vraci
          ChResult po ChOpen chybu res_ErrIllegalUnit (tato knihovna
          je knihovnou nejnizsi fyzicke vrstvy a proto se nemuze
          odkazovat na zadnou jinou nizsi).
	- Neni-li nastaven prijimaci buffer, vrati se po volani
	  metody ChConnect chyba res_ErrNoRecBuff.
	- ChOpen, ChConnect a ChClose, ChDisconnect upravuji
	  HWSyst.ActITimerClk a provadi automatickou korekci
	  systemoveho casovace.
     ChnVirt	Wil
	- Zavedeni navratovych kodu:
		res_ErrNoRecBuff     = nedefinovany prijimaci buffer
		res_ErrSmallRecBuff  = maly prijimaci buffer
		res_ErrNoSendBuff    = nedefinovany vysilaci buffer
		res_ErrSmallSendBuff = maly vysilaci buffer
     ChnVMMA	Wil
	- Pridany resulty res_ErrFrame, res_ErrSum, res_ErrLen
	- Pokud neni definovana nizsi vrstva, vrati se po ChConnect
	  chyba res_ErrChannelNoExist.
	- Rozsireni vysilani o resulty res_ErrSmallSendBuff,
          res_ErrNoSendBuff.
	- Rozsireni prijmu o resulty res_ErrNoRecBuff,
	  res_ErrSmallRecBuff.
	- Metoda ChReceiveResult vraci i pripadne chyby nizsi
	  (fyzicke) vrstvy (napr chybu parity, overrun apod).
     KitKing
        - Doplneni kontroly otevreneho kanalu
          pri vytvareni procesu.
     LdrLib
	- Zruseny typove konstanty laDataModule a liDataModuleSize
	  - nejsou potreba, pokud je aplikace pouziva (nastavuje),
	  muze se toto nastaveni zrusit.
        - LOADER pouziva protokol verze 4.
        - Rozsireni protokolu LOADER o prikazy pro cteni pametoveho bloku.
          Tato vlastnost se bude pouzivat predevsim pro cteni parametru,
          jejich konverzi a zapis.
        - Pridana struktura tHwInfo4. Oproti strukture tHwInfo byl pridan
	  parametr obsahujici verzi LOADER. Tato hodnota se v projektu
	  bude pouzivat pro omezeni projektu na min. verzi LOADER.
        - Pridana navratova hodnota eLoaderInvalidGetPar.
        - Modul s priznakem moduleattr_SrvcByApp neni kontrolovan,
          v predchozi verzi 4.XX mohla chyba v tomto modulu zpusobit
          nespusteni aplikace.
        - Pridana podpora cteni bloku pameti z prostoru DiskIO.
        - Pridany a prejmenovany chybova hlaseni cWrite_XXXX -> cMem_XXXX.
        - Pridany chybova hlaseni ze strany LOADER, tj. eLOADER_XXXX.
        - Zmena velikosti LOADER pri pouziti knihovny DiskIO,
          musi se zmenit adresa a velikost modulu, viz uxDesc.
	- Strukturu tHWInfo4 lze cist i pomoci systemoveho LA_MemoryInfoRq.
	- Pridana kontrola poctu modulu ridici aplikace v ModuleTable.
	- Zrusena konstanta xDesc.wLibVer, ktera se drive pouzivala ke kontrole
	  verze systemovych knihoven. To je ale aplikacni zalezitost a proto
	  tuto kontrolu musi provest aplikace (tj. LOADER) pomoci funkce
	  LibVer.TestLibVerNo.
	- Pri vice podminkach, kdy se nespusti ridici aplikace a ceka
	  se na komunikaci (napr. spatna ModuleTable, bParForLdr=1
          apod.) se tyto podminky kumulovaly a odmazavaly postupne
          pri kazdem reset, tj. bylo nutno provest tolik resetu, kolik
          bylo nakumulovanych podminek, nez doslo ke spusteni ridici
          aplikace. Opraveno: Pri spatne ModuleTable se vynuluje
          i pripadny bParForLdr.
	- !!!! UPOZORNENI !!!!
          Protoze v teto verzi doslo k posunuti umisteni struktur
          v pameti, <tAppRstDesc1(drive tAppRstDesc) a
	  tLdrDesc3(drive tLdrDesc, dnes tLdrDesc2)> muze se pri
	  implicitnim nastaveni stat, ze starsi aplikace pouzivajici
          predchozi rozlozeni pameti a struktury "tLdrDesc2" nebude
          schopna aktivovat "LOADER". V tomto pripade je nutne zmenit
          implicitni nastaveni umisteni techto struktur, aby se
	  prekryvaly a aplikace poskozovala strukturu tLdrDesc3.
          napr. _laAppRstDesc = 3FE08
                _laLdrDesc    = 3FDEE
	- !!!! UPOZORNENI !!!!
          Rozsireni knihoven LOADER pro podporu kopirovani
          bloku umistenych v prostoru spravovanem DiskIO.
          V souvislosti s temito zmenami byl zmenen komunikacni
          protokol, od teto verze se pouziva verze 3.
	- Opravena chyba typu promenne, ktera obsahuje cas
          posledniho spusteni aplikace (interni promenna
	  odpovidajici wExecTime).
        - Oprava typu a prejmenovani promenne, ktera obsahuje
          pocet spusteni aplikace ve sledovanem case
          (wExecNo prejmenovana na bExecNo).
	- Uprava komentaru.
        - Pridana podpora pro uzivatelske funkce Init, Write, Copy -
          tzn. podpora knihoven DiskIO
        - Upravena podpora procesoru V40. (zrusena direktiva ONLY_386).
        - Doplneni nastavovani bParForApp dle manualu.
        - Pridana podpora cteni pametovych bloku.
        - Prejmenovana konstanta
          cLdrErrDescArrayVer -> cAppRstDescVer.
        - Pridana konstanta cLdrDescVer.
        - Deklarace tAppRstDesc a tLdrDesc presunuty do XtKing_1,
          kde bylo pridano cislo znamenajici verzi struktury.
          LOADER pouziva rozsirenou strukturu tLdrDesc3.
          Predchozi verze pouzivaly strukturu tLdrDesc2.
        - Zmena implicitnich hodnot (tj. adres) _laAppRstDesc,
          _laLdrDesc.
        - Nulovani parametru pro sledovani padani aplikace se provede
          az po prijmu prikazu RESET. Predchozi verze to provadely
          po navazani komunikace.
        - Oprava vyhodnocovani CheckSum u vice modulu.
        - Optimalizace funkce CheckTime.
        - Kontrola casu z RTC, pokud je neplatny, nastavi se
          na hodnotu MinDateTime.
     NetLib	Cr
        - Oprava knihovny CoTCP, oprava nekolika malo zasadnich bot
        - Oprava CoRTL39, dodrzeni minimalni delky odesilaneho ramce
	- V knihovnach pribyla nova jednotka CoRtl39 - ovladac
  	  cipu Realtek 8139 pripojeneho na sbernici PCI
	- Doplnen priznak CPR_NO_LOWER_TICK (v CoBase)
        - Zvetsen implicitni pocet zarizeni vyssi vrstvy z 8 na 16
	- Oprava preteceni pri zvetseni vysilaciho okna nad 32KB (TCP protokol)
        - Opravy chyb pri navazovani spojeni pomoci CoAccept v protokolu TCP
     NumToStr	Wil
	- Prechod na standardni direktivy prekladu Ver60 a Ver70.
	- Pridan typ tString24 = String[24];
	- Oprava funkci StrToDate, StrToDatePT, StrToTime, StrToTimePT.
	- Uprava funkci ByteStrOct, WordStrOct, LongIntStrOct,
	  OctStrByte, OctStrWord, OctStrLongInt - pouzivani
	  kratsich stringu => setreni Stacku.
	- Pridani funkci:
		NibbleCharHex
		HexCharNibble
		DWordStrDec
		PlainBuffStrHex
		BufferStrHex2
     uString	Wil
	- Odstraneni direktiv prekladu pro Ver6.
	- Pridani funkci:
		Enlarge, EnlargeLeft, EnlargeRight
		SetLength
		ReverseStr
		WrapText
		UpCaseEach1stChar

  SW upravy zdrojaku knihoven bez zmeny kodu
     LibVer, CcittW41, DiskIO, FstTimer, G128x64, G240x128,
     GO128x64, GO240128, GraphWin, HWsyst, Chn, ChnCom, ChnCom2,
     ChnComBR, ChnComPB, ChnComT, ChnDF1, ChnVirt,
     PCKeyb, Print, RegSiso, SetupT03, SetupT05, SetupT10,
     uAMenu, uATerm, uDispT03, uDispT10, uDspT03R, uDspT10R,
     uFilter, uFlexPos, uGrObj, uCharBuf, uKeybT03, uKeybT10,
     uMenuGr, uMenuChr, uPCT01, uPCT06, uRLE1
	- Prechod na standardni direktivy prekladu Ver60 a Ver70.
          Jelikoz tato zmena nema zadny vliv na vysledny kod,
          nebyl u techto knihoven zmenen cVer a cVerNo (samozrejme,
          pokud v dane knihovne nebyly provedeny zadne dalsi zmeny).

  Stare knihovny
     ChnMod, ChnComM, ChnV40M
	- Presunuty do OLD knihoven. Pouzivat misto nich ChnMod2
	  a standardni ChnCom a ChnV40_.
     ChnCAN5
	- Presunuty do OLD knihoven, jelikoz se nikdy nepouzila
	  (nebyl pro ni dodelan HW).
     _CrtWin
	- Tuto jednotku nahrazuje CrtWin2.


Ver 03.00,01.09.2003
	- Nova verze testu pro NetLib.

   SW upravy jednotlivych knihoven
	ChnCan5  - Oprava cVerNo, oprava konverzni funkce.
        UDPPrt   - Lze provest iniciliazaci vsech vrstev knihoven
                   NetLib pomoci jednoho parameterizacniho retezce.
        WtErr	 - oprava textu str_NotImplemented
        _CrtWin  - pridana CrtClose (preklad)
                   a spravne uvolnuje pamet
        CrtWin   - pridana CrtClose (preklad)
                   uprava CrtWinExit
        CRC16    - Pridane fce CalculateCrc a CheckCrc pro blokovy
                   vypocet / kontrolu CRC
                 - Do init pridane Residue = 0
        CRC8     - Pridane funkce CalculateCrc a CheckCrc pro blokovy
                   vypocet / kontrolu CRC
                 - Do init pridane Residue = 0
        uFlexPos - Pridana fce ReRouteInputs
        LdrAFunc - Nahrazene exCrc16 -> Crc16
        XDesc    - Nahrazene exCrc16 -> Crc16
        ChnCanGl - Oprava chyby, ktera zpusobovala poskozeni
                   identifikatoru prijate zpravy (predchozi verze
                   vzdy obsahovaly priznak RTR u SJA1000)
        ChnCan1  - Oprava chyby v ChnCanGlb, ktera zpusobovala
		   poskozeni identifikatoru prijate zpravy -> nove
                   cislo verze
        ATypes   - Zrusen odkaz na exCRC16
        AVirt    - Zrusen odkaz na exCRC16
        ChnMod2  - pokud na COM neni vubec pripojen modem,
                   nehlasila se spravne chyba - opraveno
                 - metoda ChGetParam vracela spatne formatovane
                   stringy (chybely zakoncujici apostrofy) - opraveno
                 - pridelano: volani metody ChGetParam('4') vrati
                   parametry nizsi fyzicke vrstvy
                 - pridelan prikaz cmd_RecFlushHW pro metodu
                   ChSetBinParam, ktery vymaze HW prijimaci buffer
                   AT prikazu
        ChnVMMA  - opraveny konstanty hlavnich prikazu mincovniku
        NumToStr - oprava funkce PtrToStr pro Protected Mode

    Uprava knihovny - beze zmeny kodu
        uNmInt    - cVer, cVerNo - interface
        G240x128  - Oprava cVer.
        uSimT03R  - Oprava komentaru.

    Pridani / odebrani knihovny
        WatchDog  - pridano
	uTermT05  - pridano (uz bylo v SRC, jen zarazene do MakeFile)
        uSimT05   - pridano (uz bylo v SRC, jen zarazene do MakeFile)
                     + neslo prelozit s Ver6 !!! - opravy
        uIOAD03   - pridano (uz bylo v SRC, jen zarazene do MakeFile)
        SetupT05  - pridano
        F12x16pz,
        F16x32z,
        F6x8z,
        F8x8z     - fonty s azbukou - pridano
        ExCRC16   - odebrano -> do OLD
        uPort     - odebrano -> do OLD

Ver 02.00,17.03.2003
    oprava knihovny
	Loader    - oprava chyby na V40, viz LOADER\history.txt

    pridany knihovny
        LibVer    - obsahuje celkovou verzi knihoven a funkce pro praci
                    s verzemi ulozenymi v konstantach cVer, cVerNo
        UInt32    - implementace operaci s 32b cisly bez znamenka
                    (DWORD)
        HaltErr   - implementuje funkci, ktera generuje HaltErr
       	            na adrese ulozene na zasobniku (lze volat v ASM)
        ChnFT1_2  - implementace komunikacniho protokolu dle
             	    EN 60870-5-2 format FT1.2 pro vyvazeny a
                    nevyvazeny prenos (Master <-> Slave)
        FstTimer  - knihovna vznikla vyclenenim z ChnComT a V40T
                    pro odmerovani velmi kratkych intervalu

	- Do knihoven pracujicich s HEAP pridano osetreni neprovedene
          alokace (NIL) pri zapnute direktive MRE. Pri vypnute
          direktive je zachovano chovani predchozich verzi.

	- Do knihoven je pridana direktiva RT umoznujici vypnout
          ladici nastaveni a vypisy pri prekladu pro vydavanou verzi.

Ver XX.XX,XX.XX.2003
